100 REMark QL Assembly Language Editor
110 REMark Copyright (c) 1984 McGraw-Hill
120 :
130 REMark maximum number of lines and max line length
140 xl = 400 : xc = 76 : DIM txt$(xl,xc)
150 :
160 ink_col%    = 4   : REMark change for other ink colour
170 paper_col%  = 0   : REMark background colour
180 border_col% = 255 : REMark border colour for all windows
190 :
200 lncnt = 1 : mark = -1 : txt$(0) = CHR$(10)
210 true  = 1 : false = NOT true : posx = 1 : posy = 0
220 cposy = 0 : help_on = 0
230 MODE 4 : Init_Screens : Display_Page
240 :
250 ink_col%    = 4   : REMark change for other ink colour
260 paper_col%  = 0   : REMark background colour
270 border_col% = 255 : REMark border colour for all windows
280 :
290 REPeat EDt
300   AT cposy,posx-1 : CURSEN #1 : key$ = INKEY$(#1,-1)
310   key = CODE(key$) : CURDIS #1
320   SELect ON key
330     =8  : Give_Help      : REMark ^H=help
340     =19 : Save_File      : REMark ^S=save
350     =12 : Load_File      : REMark ^L=load
360     =5  : Do_Ext_Command : REMark ^E=execute
370     =13 : Set_Marker     : REMark ^M=marker
380     =6  :                  REMark ^F=finish
390       CLS #0 : AT #0,1,4 : PRINT #0,'Are you sure ? ';
400       CURSEN #0 : c$ = INKEY$(#0,-1) : CURDIS #0
410       IF c$=='y' : PRINT#0,'Y' : EXIT EDt : ELSE : help_on = 0 : Heading
420     =REMAINDER : Perform_Edit
430   END SELect
440 END REPeat EDt
450 :
460 INK #2,ink_col% : REMark for BASIC editing
470 STOP
480 :
490 REMark End of editor
500 :
510 REMark Procedures for editor
520 REMark ---------------------
530 :
540 DEFine PROCedure Init_Screens
550   LOCal c
560   OPEN #3,con_
570   CLS#0 : PAPER #1,paper_col% : PAPER #2,paper_col% : WINDOW #1,512,256,0,0 : CLS #1
580   WINDOW #0,448,51,38,205 : WINDOW #1,448,173,38,32
590   WINDOW #2,448,16,38,16 : WINDOW #3,448,16,38,0
600   FOR c = 0 TO 3 : CSIZE #c,0,0 : INK #c,ink_col% : CLS #c
610   FOR c = 0 TO 2 : BORDER #c,1,border_col%
620   FOR c = 1 TO 9 : PRINT #2,'^.......';
630   Heading
640   Display_Use
650   Display_Mark
660   Display_Line
670 END DEFine Init_Screens
680 :
690 DEFine PROCedure Give_Help
700   IF help_on : help_on = 0 : Heading : RETurn
710   help_on = 1 : CLS #0 : AT #0,0,0
720   UNDER #0,1 : PRINT #0,'Cursor'
730   PRINT #0,'Control:        NORMAL   : ';
740   PRINT #0,'SHIFT :     ALTMODE      :     CONTROL      '
750   UNDER #0,0
760   PRINT #0,'           ';CHR$(190);CHR$(191);':   line    : page  ';
770   PRINT #0,': (start/end) text :   DELETE Line'
780   PRINT #0,'           ';CHR$(188);CHR$(189);': character : word  ';
790   PRINT #0,': (start/end) line : DELETE Char/Gap'
800 END DEFine Give_Help
810 :
820 DEFine PROCedure Save_File
830   CLS #0
840   AT #0,1,0 : UNDER #0,1 : PRINT #0, 'Saving file' : UNDER #0,0
850   IF mark <> -1 THEN
860     PRINT #0,'>>> Marker line exists' : User_Wait : GO TO 900
870   END IF
880   Get_Filename : DELETE fnam$ : OPEN_NEW #5,fnam$
890   PRINT #5,txt$(0 TO lncnt-1); : CLOSE #5
900   help_on = 0 : Heading
910 END DEFine Save_File
920 :
930 DEFine PROCedure Load_File
940   CLS #0
950   AT #0,1,0 : UNDER #0,1 : PRINT #0, 'Loading file' : UNDER #0,0
960   CLS : posx = 1 : posy = 0 : cposy = 0 : txt$(0) = ''
970   mark = -1 : Get_Filename : OPEN_IN #5,fnam$ : c = 0
980   IF EOF(#5) : GO TO 1000 : ELSE INPUT #5,ln$
990   txt$(c) = ln$ & CHR$(10) : c = c + 1 : GO TO 980
1000   CLOSE #5 : Heading : lncnt = c : IF c > 16 : c = 16
1010   AT 0,0 : PRINT txt$(0 TO c);
1020   help_on = 0 : Display_Use : Display_Mark : Display_Line
1030 END DEFine Load_File
1040 :
1050 DEFine PROCedure Merge_File
1060   CLS #0 : AT #0,1,0
1070   UNDER #0,1 : PRINT #0,'Including external file' : UNDER #0,0
1080   IF mark <> -1 THEN
1090     PRINT #0,'>>> Marker line exists'; : User_Wait : GO TO 1200
1100   END IF
1110   posx = 1 : Get_Filename : OPEN_IN #5,fnam$ : c = posy : k = 0
1120   IF EOF(#5) : GO TO 1190 : ELSE : INPUT #5,ln$
1130   k = (k+1) MOD 10 : IF k = 0 : PRINT #0,'+';
1140   IF lncnt > xl - 3
1150     PRINT #0,'>>> Not enough room'; : User_Wait : GO TO 1190
1160   END IF
1170   FOR cnt = lncnt TO c STEP -1 : txt$(cnt + 1) = txt$(cnt)
1180   txt$(c) = ln$ & CHR$(10) : c = c+1 : lncnt = lncnt+1 : GO TO 1120
1190   CLOSE #5
1200   help_on = 0 : Heading : Display_Page : Display_Use
1210 END DEFine Merge_File
1220 :
1230 DEFine PROCedure Do_Ext_Command
1240   CLS #0 : AT #0,1,0 : UNDER #0,1 : PRINT #0,'Options:' : UNDER#0,0
1250   PRINT#0,'   (F)ind string        :   (M)ove to line'
1260   PRINT#0,'   (D)elete block       :   (I)nclude file      >>> ';
1270   c$ = INKEY$(#0,-1) : c = c$ INSTR 'FDMI'
1280   IF c = 0 : GO TO 1270 : ELSE : CLS#0
1290   SELect ON c
1300     =1 : REMark Find string
1310       AT #0,1,0 : INPUT#0,'String to search for: ';s$ : i = posy
1320       REPeat scan
1330         p = s$ INSTR txt$(i) : IF p = 0 : GO TO 1350
1340         cposy = i : posy = i : posx = p : Display_Page : EXIT scan
1350         IF i = lncnt - 1 : EXIT scan : ELSE : i = i + 1
1360       END REPeat scan
1370     =2 : REMark Move to line
1380       AT #0,1,0
1390       IF mark = -1 THEN
1400         PRINT #0,'>>> No marker line'; : User_Wait : GO TO 1610
1410       END IF
1420       IF posy < mark : a = mark : mark = posy : posy = a
1430       posx = 1 : cposy = mark
1440       IF posy = lncnt - 1 THEN
1450         lncnt = lncnt + 1
1460         FOR cnt = mark TO posy : txt$(cnt) = CHR$(10)
1470       ELSE
1480         n = lncnt - posy - 1
1490         FOR cnt = 0 TO n : txt$(mark+cnt) = txt$(posy+cnt+1)
1500       END IF
1510       olc = lncnt
1520       lncnt = lncnt - ((posy-mark)+1) : posy = cposy : mark = -1
1530       FOR cnt = lncnt + 1 TO olc : txt$(cnt) = ''
1540       Display_Page : Display_Use : Display_Mark
1550     =3 : REMark Delete block
1560       CLS #0 : AT #0,1,2 : PRINT #0,'Line (number) to move to ?  ';
1570       INPUT #0,n : IF n < 0 : n = 0
1580       IF n > lncnt - 1 : n = lncnt - 1
1590       posx = 1 : posy = n : cposy = n : Display_Page
1600     =4 : Merge_File : REMark Include file
1610   END SELect
1620   help_on = 0
1630   Heading
1640 END DEFine Do_Ext_Command
1650 :
1660 DEFine PROCedure Set_Marker
1670   IF mark <> -1 : RETurn
1680   mark = posy : posx = 1
1690   key = 185 : key$ = CHR$(185) : Perform_Edit
1700   Display_Mark
1710 END DEFine Set_Marker
1720 :
1730 DEFine PROCedure Kill_Line
1740   IF lncnt = posy+1 : RETurn
1750   IF mark <> -1 : BEEP 800,2 : RETurn
1760   posx = 1 : FOR c = posy + 1 TO lncnt : txt$(c-1) = txt$(c)
1770   IF lncnt <> 1 : lncnt = lncnt - 1
1780   IF cposy = 0 : SCROLL -10 : GO TO 1800
1790   AT cposy-1,0 : SCROLL -10,2 : AT cposy,0
1800   IF cposy = 8 THEN
1810     IF LEN(txt$(posy+7)) <> 0 : AT 16,0 : PRINT txt$(posy+8);
1820   ELSE
1830     IF LEN(txt$(16)) <> 0 : AT 16,0 : PRINT txt$(16);
1840   END IF
1850   Display_Use
1860 END DEFine Kill_Line
1870 :
1880 DEFine PROCedure Perform_Edit
1890   SELect ON key
1900     =210,218 : Kill_Line
1910     =CODE(' ') TO CODE('~'), 185 : Ch_Enter
1920     =9   : Tab_Enter
1930     =10  : Newline
1940     =208 : Up_Line
1950     =216 : Down_Line
1960     =193 : posx = 1
1970     =201 : posx = LEN(txt$(posy))
1980     =200 : IF posx <> LEN(txt$(posy)):posx=posx+1
1990     =192 : IF posx <> 1 : posx = posx - 1
2000     =209 : St_Text
2010     =217 : End_Text
2020     =212 : Up_Page
2030     =220 : Down_Page
2040     =196 : Word_Left
2050     =204 : Word_Right
2060     =202 : Del_Forw
2070     =194 : Del_Back
2080     =REMAINDER : REMark ignore
2090   END SELect
2100 END DEFine Perform_Edit
2110 :
2120 DEFine PROCedure Ch_Enter
2130   IF (posx = xc-4) OR (LEN(txt$(posy)) >= xc-4) : RETurn
2140   IF Line_End THEN
2150     AT cposy,posx-1 : PRINT key$;
2160     IF posx = 1 : txt$(posy) = '' : GO TO 2180
2170     txt$(posy) = txt$(posy,1 TO LEN(txt$(posy))-1)
2180     txt$(posy) = txt$(posy) & key$ & CHR$(10)
2190     posx = posx + 1
2200   ELSE
2210     AT cposy,posx-1 : PAN 6,4
2220     AT cposy,posx-1 : PRINT key$; : posx = posx + 1
2230     xtra$ = txt$(posy,posx-1 TO LEN(txt$(posy)))
2240     IF posx = 2 : txt$(posy) = '' : GO TO 2260
2250     txt$(posy) = txt$(posy,1 TO posx-2)
2260     txt$(posy) = txt$(posy) & key$ & xtra$
2270   END IF
2280 END DEFine Ch_Enter
2290 :
2300 DEFine PROCedure Tab_Enter
2310   IF (posx >= xc-8) OR (LEN(txt$(posy)) >= xc-8) : RETurn
2320   gap = 8 - ((posx-1) MOD 8)
2330   IF NOT Line_End THEN
2340     xtra$ = txt$(posy,posx TO LEN(txt$(posy)))
2350     IF posx = 1 : txt$(posy) = '' : GO TO 2370
2360     txt$(posy) = txt$(posy,1 TO posx-1)
2370     txt$(posy) = txt$(posy) & FILL$(' ',gap) & xtra$
2380   ELSE
2390     IF posx = 1 : txt$(posy) = '' : GO TO 2410
2400     txt$(posy) = txt$(posy,1 TO LEN(txt$(posy))-1)
2410     txt$(posy) = txt$(posy)& FILL$(' ',gap)& CHR$(10)
2420   END IF
2430   posx = ((posx-1) DIV 8)*8+9 : AT cposy,0 : PRINT txt$(posy);
2440 END DEFine Tab_Enter
2450 :
2460 DEFine PROCedure Newline
2470   oldx = posx : posx = 1
2480   IF oldx = 1 THEN
2490     IF lncnt = xl - 2 : RETurn
2500     lncnt = lncnt + 1
2510     FOR c = lncnt - 1 TO posy STEP -1 : txt$(c+1) = txt$(c)
2520     IF cposy = 0 : SCROLL 10 : GO TO 2540
2530     AT cposy-1,posx : SCROLL 10,2 : AT cposy,posx-1
2540     txt$(posy) = CHR$(10)
2550   ELSE
2560     posy = posy + 1 : IF lncnt = xl - 2 : RETurn
2570     IF LEN(txt$(posy)) = 0 THEN
2580       txt$(posy) = CHR$(10) : lncnt = lncnt + 1
2590       IF cposy = 8 THEN
2600         AT cposy+1,posx-1 : SCROLL -10,1
2610         AT cposy,posx-1
2620         ELSE
2630         cposy = cposy + 1
2640       END IF
2650     ELSE
2660       IF cposy = 8 THEN
2670         SCROLL -10
2680         IF LEN(txt$(posy+7)) <> 0 : AT 16,0 : PRINT txt$(posy+8);
2690       ELSE
2700         cposy = cposy + 1
2710       END IF
2720     END IF
2730   END IF
2740   Display_Use : Display_Line
2750 END DEFine Newline
2760 :
2770 DEFine PROCedure Up_Line
2780   IF posy = 0 : RETurn
2790   IF posy > 8 THEN
2800     SCROLL 10 : AT 0,0 : PRINT txt$(posy-9); : AT cposy,posx-1
2810   ELSE
2820     cposy = cposy-1
2830   END IF
2840   IF posx > LEN(txt$(posy-1)) : posx = LEN(txt$(posy-1))
2850   posy = posy-1
2860   Display_Line
2870 END DEFine Up_Line
2880 :
2890 DEFine PROCedure Down_Line
2900   IF posy = lncnt - 1 : RETurn
2910   IF posy > 7 THEN
2920     SCROLL -10 : AT 16,0 : PRINT txt$(posy+9); : AT cposy,posx - 1
2930   ELSE
2940     cposy = cposy + 1
2950   END IF
2960   IF posx > LEN(txt$(posy+1)) : posx = LEN(txt$(posy+1))
2970   posy = posy + 1
2980   Display_Line
2990 END DEFine Down_Line
3000 :
3010 DEFine PROCedure St_Text
3020   CLS : CURSEN : posx = 1 : posy = 0 : cposy = 0
3030   n=lncnt-1:AT 0,0:IF n>16:n=16
3040   PRINT txt$(0 TO n);:Display_Line
3050 END DEFine St_Text
3060 :
3070 DEFine PROCedure End_Text
3080   posx=1:posy=lncnt-1
3090   IF lncnt<=9
3100     cposy=posy
3110   ELSE
3120     CLS:CURSEN:AT 0,0:cposy=8
3130     PRINT txt$(posy-8 TO posy);
3140   END IF
3150   Display_Line
3160 END DEFine End_Text
3170 :
3180 DEFine PROCedure Up_Page
3190   IF posy = 0 : RETurn
3200   posx = 1 : nl = posy - 16 : IF nl < 0 : nl = 0
3210   posy = nl : cposy = posy : Display_Page
3220 END DEFine Up_Page
3230 :
3240 DEFine PROCedure Down_Page
3250   IF posy = lncnt - 1 : RETurn
3260   posx = 1 : nl = posy + 16 : IF nl > lncnt - 1 : nl = lncnt - 1
3270   posy = nl : cposy = posy : Display_Page
3280 END DEFine Down_Page
3290 :
3300 DEFine PROCedure Word_Left
3310   IF posx = 1 : RETurn
3320   IF posx = LEN(txt$(posy)) : posx = posx - 1
3330   posx = posx - 1 : IF posx = 1 : RETurn
3340   IF txt$(posy,posx) = ' ' : GO TO 3330
3350   posx = posx - 1 : IF posx = 1 : RETurn
3360   IF txt$(posy,posx) <> ' ' : GO TO 3350
3370   posx = posx + 1
3380 END DEFine Word_Left
3390 :
3400 DEFine PROCedure Word_Right
3410   IF posx = LEN(txt$(posy)) : RETurn
3420   posx = posx + 1 : IF posx = LEN(txt$(posy)) : RETurn
3430   IF txt$(posy,posx) <> ' ' : GO TO 3420
3440   posx = posx + 1 : IF posx = LEN(txt$(posy)) : RETurn
3450   IF txt$(posy,posx) = ' ' : GO TO 3440
3460 END DEFine Word_Right
3470 :
3480 DEFine PROCedure Del_Forw
3490   ll = LEN(txt$(posy)) : IF posx = ll : RETurn
3500   IF txt$(posy,posx) = CHR$(185) : mark=-1 : Display_Mark
3510   IF txt$(posy,posx) <> ' ' THEN
3520     IF posx = 1 : txt$(posy) = txt$(posy,posx+1 TO ll) : GO TO 3540
3530     txt$(posy) = txt$(posy,1 TO posx-1) & txt$(posy,posx+1 TO ll)
3540     AT cposy,posx-1 : PAN -6,4
3550   ELSE
3560     IF posx = 1 : txt$(posy) = txt$(posy,posx+1 TO ll) : GO TO 3580
3570     txt$(posy) = txt$(posy,1 TO posx-1) & txt$(posy,posx+1 TO ll)
3580     AT cposy,posx-1 : PAN -6,4
3590     ll = ll - 1 : IF posx = ll : GO TO 3610
3600     IF txt$(posy,posx) = ' ' : GO TO 3560
3610   END IF
3620 END DEFine Del_Forw
3630 :
3640 DEFine PROCedure Del_Back
3650   ll = LEN(txt$(posy)) : IF posx = 1 : RETurn
3660   IF txt$(posy,posx-1) = CHR$(185) : mark = -1 : Display_Mark
3670   IF txt$(posy,posx-1) <> ' ' THEN
3680     IF posx = 2 : txt$(posy) = txt$(posy,posx TO ll) : GO TO 3700
3690     txt$(posy) = txt$(posy,1 TO posx-2) & txt$(posy,posx TO ll)
3700     AT cposy,posx-2 : PAN -6,4 : posx = posx - 1
3710   ELSE
3720     IF posx = 2 : txt$(posy) = txt$(posy,posx TO ll) : GO TO 3740
3730     txt$(posy) = txt$(posy,1 TO posx-2) & txt$(posy,posx TO ll)
3740     AT cposy,posx-2 : PAN -6,4 : posx = posx - 1
3750     ll = ll - 1 : IF posx = 1 : GO TO 3770
3760     IF txt$(posy,posx-1) = ' ' : GO TO 3720
3770   END IF
3780 END DEFine Del_Back
3790 :
3800 DEFine FuNction Line_End
3810   IF posx = LEN(txt$(posy)) : RETurn true
3820   RETurn false
3830 END DEFine Line_End
3840 :
3850 DEFine PROCedure Display_Line
3860   REMark show line number down file
3870   AT #3,0,54 : PRINT #3,'Line:    ';
3880   AT #3,0,60 : PRINT #3,posy;
3890 END DEFine Display_Line
3900 :
3910 DEFine PROCedure Display_Use
3920   REMark show number of lines used
3930   AT #3,0,13 : PRINT #3,'Lines used:    ';
3940   AT #3,0,25 : PRINT #3,lncnt - 1;
3950 END DEFine Display_Use
3960 :
3970 DEFine PROCedure Display_Mark
3980   AT #3,0,32 : PRINT #3,'Marker line:    '; : AT #3,0,45
3990   IF mark <> -1 : PRINT#3,mark;
4000 END DEFine Display_Mark
4010 :
4020 DEFine PROCedure Heading
4030   CLS #0 : AT #0,1,1 : UNDER #0,1 : PRINT #0,'EDIT v1.2'
4040   AT #0,1,39
4050   PRINT #0,'Copyright (c) 1984 McGraw-Hill(UK)' : UNDER #0,0
4060   PRINT #0,\' ^H : Help  ^L : Load  ^S : Save  ^E : Execute';
4070   PRINT #0,'  ^M : Marker  ^F : Finish'
4080 END DEFine Heading
4090 :
4100 DEFine PROCedure Get_Filename
4110   AT #0,2,0 : INPUT #0,'Device_Filename:  ';fnam$
4120   IF LEN(fnam$) > 5 THEN
4130     IF CHR$(95) INSTR fnam$(6 TO LEN(fnam$)) = 0 THEN
4140       REMark no underscore, so add _asm extension
4150       fnam$ = fnam$ & '_asm'
4160     END IF
4170   END IF
4180 END DEFine Get_Filename
4190 :
4200 DEFine PROCedure Display_Page
4210   CLS : AT 0,0 : n = lncnt - 1
4220   IF posy <= 8 THEN
4230     IF n > 16 : n = 16
4240     PRINT txt$(0 TO n);
4250   ELSE
4260     cposy = 8 : IF n > posy + 8 : n = posy + 8
4270     PRINT txt$(posy-8 TO n);
4280   END IF
4290   Display_Line
4300 END DEFine Display_Page
4310 :
4320 DEFine PROCedure User_Wait
4330   BEEP 800,2 : dummy$ = INKEY$(#0,-1)
4340 END DEFine User_Wait
4350 :
4360 DEFine PROCedure Sa
4370   SAVE win1_dedit_McG_ed_bas : QSAVE win1_dedit_McG_ed
4380 END DEFine Sa
